const Cc = Components.classes;
const Ci = Components.interfaces;

function loadjq() {
  var subscriptLoader = Cc["@mozilla.org/moz/jssubscript-loader;1"]
    .getService(Ci.mozIJSSubScriptLoader);
  var foo = subscriptLoader.loadSubScript("chrome://l10n-bug-comp/content/jquery.js");
}

var hooks = {};

function Nowizard(aDeckID, aNextID, aBackID) {
  this._elem = document.getElementById(aDeckID);
  this._next = document.getElementById(aNextID);
  this._back = document.getElementById(aBackID);
  this._se = 0;
  this._elem.selectedIndex = this._se;
}
Nowizard.prototype = {
 next: function() {
    this._elem.selectedIndex = ++this._se;
    this._back.hidden = false;
    if (this._se == this._elem.childNodes.length - 1) {
      this._next.hidden = true;
    }
  },
 back: function() {
    this._elem.selectedIndex = --this._se;
    this._next.hidden = false;
    if (this._se == 0) {
      this._back.hidden = true;
    }
  },
 set canAdvance(truth) {
   this._next.disabled = !truth;
 },
 get canAdvance() {
   return !this._next.disabled;
 }
};

var nowizard, bc;

function loadFrame(url, cb) {
  var frm = $("<iframe/>").attr({
      "style":"display:none",
        "flex":"1",
        "type": "content-targetable"});
  var msg = $('<description/>').text('Loading ' + url + ' ...');
  $('#msgs').append(msg);
  frm.load(function(e) {
      console.log('load done');
      msg.append('Done.');
      cb(e);
      window.setTimeout(function(){frm.remove()}, 0);
    })
  $("#frms").append(frm);
  frm.attr('src', url);
  return frm;
}

function onload() {
  nowizard = new Nowizard('nw_deck', 'nw_next', 'nw_back');
  bc = {url: document.getElementById('bz-instance').value};
  var msg = document.createElement('description');
  msg.textContent = 'Preloading ' + bc.url + '... ';
  $('#msgs').append(msg);
  $.getJSON(bc.url+'config.cgi', {flags:0, ctype:'json'},
            function(config_json) {
              msg.textContent += 'Done.';
              config_json.url = bc.url;
              bc = config_json;
            });
}

var state = {
  locales: null,
  components: null
};

var check = {
  locales: function(){
    var canAdvance = false;
    var content = document.getElementById('locales').value;
    var lines = content.trim().split(/\n+/);
    state.locales = {}
    for each (var line in lines) {
      if (!line) continue;
      var match = /^([a-zA-Z\-]+)\s+(.*)/.exec(line);
      if (!match) { canAdvance = false ; break}
      canAdvance = true;
      state.locales[match[1]] = match[2];
    }
    nowizard.canAdvance = canAdvance;
  }
};

var controller = {
 size: function(_frm) {
    var contViewer = _frm.docShell.contentViewer;
    var docViewer = contViewer.QueryInterface(Components.interfaces.nsIMarkupDocumentViewer);
    docViewer.fullZoom = 0.5;
  },
 byId: function(aID) {
    return document.getElementById(aID);
  },
 alias: function(loc, thingie) {
    var sub = '';
    if (thingie) {
      sub = thingie.toLowerCase() + ".";
    }
    return loc + "@" + sub + "localization.bugs";
  },
 instance: function(page) {
    state.instance = this.byId('bz-instance').value;
    state.comps = new RDFBugConfig(state.instance);
  },
 components: function() {
    state.thingies = [];
    var page = document.getElementById('bugsWizard').currentPage;
    var _bxs =  page.querySelectorAll('checkbox');
    for (var i=0, ii=_bxs.length; i <ii; ++i) {
      var checkbx = _bxs[i];
      if (checkbx.checked) {
        state.thingies.push(checkbx.label);
      }
    }
  },
 preschemes: function(page) {
    page.parentNode.canAdvance = false;
    state.comps.waitForLoaded(function(_page) {
        _page.parentNode.canAdvance = true;
      }, page, [page]);
  },
 schemes: function(page) {
    state.products = [];
    state.components = [];
    var schemes = {}, _bxes = page.querySelectorAll('checkbox[checked=true]');
    for (var i=0, ii=_bxes.length; i < ii; ++i) {
      var cbox = _bxes[i];
      schemes[cbox.id] = this.byId(cbox.id+"-detail").value;
    }
    if ('scheme-loc' in schemes) {
      // Create a product per locale, and components per thingie
      var cat = schemes['scheme-loc'];
      for (var loc in state.locales) {
        var langName = state.locales[loc];
        var prodName = "l10n: " + langName + " / " + loc;
        var desc = langName + " localization bugs";
        if (!state.comps.hasProduct(prodName)) {
          state.products.push([cat, prodName, desc]);
        }
        for each (var thingie in state.thingies) {
            var cmpName = thingie;
            if (state.comps.hasComponent(prodName, cmpName)) {
              continue;
            }
            var cmpDesc = langName + " " + thingie + " localization";
            var qa = this.alias(loc, thingie);
            var defaultCC = [this.alias(loc)];
            state.components.push([prodName, cmpName, cmpDesc, qa, defaultCC]);
          }
      }
    }
    if ('scheme-prod' in schemes) {
      // Create a product per locale, and components per thingie
      var cat = schemes['scheme-prod'];
      for each (var thingie in state.thingies) {
          var prodName = thingie + " Localizations";
          var desc = thingie + " localization bugs";
          if (!state.comps.hasProduct(prodName)) {
            state.products.push([cat, prodName, desc]);
          }
          for (var loc in state.locales) {
            var langName = state.locales[loc];
            var cmpName = langName;
            if (state.comps.hasComponent(prodName, cmpName)) {
              continue;
            }
            var cmpDesc = langName + " " + thingie + " localization";
            var qa = this.alias(loc, thingie);
            var defaultCC = [this.alias(loc)];
            state.components.push([prodName, cmpName, cmpDesc, qa, defaultCC]);
          }
      }
    }
    if ('scheme-loc-prod' in schemes) {
      // Create a product per locale, and components per thingie
      var prodName = schemes['scheme-loc-prod'];
      for each (var thingie in state.thingies) {
          for (var loc in state.locales) {
            var langName = state.locales[loc];
            var cmpName = langName + " " + thingie + " / " + loc;
            if (state.comps.hasComponent(prodName, cmpName)) {
              continue;
            }
            var cmpDesc = langName + " " + thingie + " localization";
            var qa = this.alias(loc, thingie);
            var defaultCC = [this.alias(loc)];
            state.components.push([prodName, cmpName, cmpDesc, qa, defaultCC]);
          }
      }
    }
    var wait=6;
  },
 computeAliases: function() {
    state.aliases = {};
    for (var loc in state.locales) {
      state.aliases[loc + "@localization.bugs"] = state.locales[loc] + " watcher";
      for each (var cmp in state.thingies) {
          state.aliases[this.alias(loc, cmp)] = state.locales[loc] + " " + cmp + " watcher";
        }
    }
  },
 getAliases: function() {
    this.computeAliases();
    var url = bc.url+"editusers.cgi?action=list&matchvalue=login_name&matchstr=localization.bugs&matchtype=substr&groupid=12";

  },
 lga: function(event) {
    var foo = bar;
  },
 loadGetAliasFrame: function (frm) {
    return function (e) {
      var editNodes = this.contentDocument.querySelectorAll('a[href*="action=edit"]');
      for (var i = 0, ii = editNodes.length; i< ii; ++i) {
        var exists = editNodes[i].textContent.trim();
        if (exists in state.aliases) {
          delete state.aliases[exists];
        }
      }
      Components.utils.reportError(state.aliases.toSource());
      frm.parentNode.removeChild(frm);
    }
  },
 startCreatingAliases: function(page) {
    if (!state.aliases) {
      page.parentNode.advance();
      return;
    }
    page.parentNode.canAdvance = true; // XXX alias disabled
    var prog = this.byId('alias_progress');
    prog.max = state.aliases.length;
    prog.value = 0;
    var frm = this.byId('create_user');
    this.size(frm);
    var login, name, stack = [], progval = 0;
    function loadHandler() {
      if (stack.length) {
        var handler = stack.shift();
        handler[0].apply(frm, handler[1]);
      }
    }
    function loadEditUsers(_pv) {
      prog.value = _pv;
      this.setAttribute('src', state.instance + "/editusers.cgi?action=add");
    }
    for (login in state.aliases) {
      name = state.aliases[login];
      stack.push([loadEditUsers,[progval]]);
      stack.push([this.submitAccountData, [login, name]]);
      progval += 1;
    }
    stack.push([this.cleanLogins, [loadHandler, page]]);
    frm.addEventListener("DOMContentLoaded", loadHandler, false);
    loadHandler();
  },
 submitAccountData: function(login, name) {
    var _form;
    for each (_form in this.contentDocument.forms){
        if (_form.elements && _form.elements[0].name == "login") {
          break;
        }
      }
    _form[0].value = login;
    _form[1].value = name;
    var _pwd = '';
    for (var i=0;i<16;++i){
      _pwd += String.fromCharCode(65+Math.floor(Math.random()*26));
    }
    _form[2].value = _pwd;
    //_form.submit(); XXX alias disabled
    var _j = this;
    function _blank() {
      _j.setAttribute('src', 'about:blank');
    }
    //window.setTimeout(_blank, 1000);
  },
 cleanLogins: function(handler, page) {
    this.removeEventListener("DOMContentLoaded", handler, false);
    if (page) {
      page.parentNode.canAdvance = true;
    }
  },
 startCreatingProducts: function(page) {
    if (!state.products.length) {
      page.parentNode.advance();
      return;
    }
    page.parentNode.canAdvance = false;
    var frame = this.byId('create_prods');
    this.size(frame);
    var _page = page;
    var self = this;
    function iterProduct(index) {
      var cb = null, cbargs = null;
      if (index < state.products.length - 1) {
        cb = iterProduct;
        cbargs = [index + 1];
      } else {
        cb = function() {
          _page.parentNode.canAdvance = true;
        }
        cbargs = [];
      }
      var prod = state.products[index];
      self.addProduct(_frm, prod[0], prod[1], prod[2], iterProduct, cbargs);
    };
    iterProduct(0);
  },
 addProduct: function(frame, classification, product, description, cb, cbargs) {
    var url = "https://landfill.bugzilla.org/l10ntest/editproducts.cgi?action=add&classification=" + classification;
    var stack = [];
    function _onLoad() {
      if (stack.length) {
        var _handler = stack.shift();
        _handler[0].apply(frame, _handler[1]);
      }
    }
    function handleProduct(_p, _d) {
      var _form;
      for each (_form in document.forms){
          if (_form.elements && _form.elements[0].name=="product") {
            break;
          }
        }
      _form.elements[0].value = _p;
      _form.elements[1].value = _d;
      //_form.submit();
    }
    stack.push([handleProduct, [product, description]]);
    var self = this;
    function onDone() {
      this.removeEventListener("DOMContentLoaded", _onLoad, false);
      if (cb) {
        cb.apply(self, cbargs);
      }
    }
    stack.push([onDone, []]);
    frame.addEventListener("DOMContentLoaded", _onLoad, false);
    frame.setAttribute('src', url);
  }
};
