from glob import glob
from collections import defaultdict

files = '''mozilla-central/browser/locales/all-locales comm-central/*/locales/all-locales mobile-browser/locales/all-locales releases/mozilla-1.9.?/browser/locales/all-locales releases/comm-1.9.?/*/locales/all-locales releases/mobile-1.1/locales/all-locales'''

loc2mod = defaultdict(set)

for _g in files.split():
    for allf in glob(_g):
        mod = ("./" + allf).rsplit('/',3)[1]
        if mod.startswith('mobile'):
            mod = 'mobile'
        locs = open(allf).read().split()
        for loc in filter(None, locs):
            if loc != 'ja-JP-mac':
                loc2mod[loc].add(mod)

mods2locs = defaultdict(set)
for loc in sorted(loc2mod.keys()):
    mods = tuple(sorted(loc2mod[loc]))
    mods2locs[mods].add(loc)

for mods in sorted(mods2locs.keys()):
    print mods, " ".join(sorted(mods2locs[mods]))
